﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml.Xsl;

namespace Apollo
{
    public partial class EmergencyOverride : Form
    {
        private Status s { get; set; }
        private bool Up = false;
        private bool Left = false;
        private bool Right = false;
        private Image lander = Image.FromFile("lunar_lander.png");
        public EmergencyOverride(Status st)
        {
            s = st;
            DoubleBuffered = true;
            InitializeComponent();
            DoubleBuffered = true;
            ticker.Enabled = true;
            System.Reflection.PropertyInfo aProp =
                typeof(System.Windows.Forms.Control).GetProperty(
                    "DoubleBuffered",
                    System.Reflection.BindingFlags.NonPublic |
                    System.Reflection.BindingFlags.Instance);

            aProp.SetValue(panel1, true, null);
        }

        private void EmergencyOverride_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Left)
                Left = true;
            if (e.KeyCode == Keys.Right)
                Right = true;
            if (e.KeyCode == Keys.Up)
                Up = true;
        }

        private void EmergencyOverride_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Left)
                Left = false;
            if (e.KeyCode == Keys.Right)
                Right = false;
            if (e.KeyCode == Keys.Up)
                Up = false;
        }

        private void EmergencyOverride_Paint(object sender, PaintEventArgs e)
        {
            //var minX = s.X - 
            //g.DrawImage(lander,);

        }

        private async void ticker_Tick(object sender, EventArgs e)
        {
            var update = Lander.Update(s.Url, s.id, Up, Left, Right);
            s = await update;

            label1.Text = "Palivo: " + s.Fuel + "Jakopaliva";
            label2.Text = "RychlostDolu: " + s.dY + "Jakometru/jakojednotkucasu";
            label3.Text = "RychlostDoprava: " + s.dX + "Jakometru/jakojednotkucasu";
            label4.Text = "Vyska: " + s.Y + "Jakometru/jakojednotkucasu";
            pictureBox1.Visible = Left;
            pictureBox3.Visible = Up;
            pictureBox2.Visible = Right;
            if (s.End)
            {
                ticker.Enabled = false;
                MessageBox.Show(s.Success ? "Vyborne" : "Treba priste, nepovedlo se :{");
                return;
            }
            panel1.Invalidate();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

            var height = 200;
            var width = 200;
            var g = e.Graphics;
            g.SmoothingMode = SmoothingMode.HighQuality;
            g.InterpolationMode = InterpolationMode.HighQualityBicubic;
            g.PixelOffsetMode = PixelOffsetMode.HighQuality;
            g.Clear(Color.White);
            var midPointX = s.PlatformStart + (s.PlatformEnd - s.PlatformStart) / 2;
            var maxX = Math.Abs((s.X + (float)Math.Sign(s.X) * 10f) - (float)(midPointX));

            this.Text = s.X.ToString() + " :" + s.dX;
            g.TranslateTransform(0, height - 10f);
            g.DrawLine(Pens.Black, 0, 0, width, 0);
            g.DrawLine(Pens.Red, (float)s.PlatformStart, 0, (float)s.PlatformEnd, 0);
            g.DrawImage(lander, new RectangleF((float)s.X - 10f, -(float)s.Y - 10f, 20, 20));

       }
    }
}
