﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace Apollo
{
    public static class Lander
    {
        public static async Task<Status> Update(string url, int id, bool up, bool left, bool right)
        {
            var c = new HttpClient();
            var address = url.ToLower();
            if (!address.StartsWith("http://"))
                address = "http://" + address;
            if (address.EndsWith("/"))
                address = address + "stav";
            else
                address = address + "/stav";
            address = address + $"?id={id}&nahoru={(up ? 1 : 0)}&doleva={(left ? 1:0)}&doprava={(right ? 1 : 0)}";
            var taskGet = c.GetAsync(new Uri(address));

            var page = await taskGet;
            var taskContent = page.Content.ReadAsStringAsync();

            var responce = await taskContent;
            if (responce == "Krach!")
                return new Status() { Success = false, End = true };
            if (responce == "Zdar!")
                return new Status() { Success = true, End = true };
            var parsed = responce.Split(new[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
            var location = parsed[1].Split(' ');
            var speed = parsed[2].Split(' ');
            var platform = parsed[4].Split(' ');
            return new Status()
            {
                Url = url,
                id = Int32.Parse(parsed[0]),
                dX = Double.Parse(speed[0]),
                dY = Double.Parse(speed[1]),
                X = Double.Parse(location[0]),
                Y = Double.Parse(location[1]),
                Fuel = Double.Parse(parsed[3]),
                PlatformStart = Double.Parse(platform[0]),
                PlatformEnd = Double.Parse(platform[1])
            };
        }
        public static async Task<Status> New(string url)
        {
            var c = new HttpClient();
            var address = url.ToLower();
            if (!address.StartsWith("http://"))
                address = "http://" + address;
            if (address.EndsWith("/"))
                address = address + "start";
            else
                address = address + "/start";

            var taskGet = c.GetAsync(new Uri(address));

            var page = await taskGet;
            var taskContent = page.Content.ReadAsStringAsync();

            var responce = await taskContent;

            var parsed = responce.Split(new [] {Environment.NewLine},StringSplitOptions.RemoveEmptyEntries);
            var location = parsed[1].Split(' ');
            var speed = parsed[2].Split(' ');
            var platform = parsed[4].Split(' ');
            return new Status()
            {
                Url = url,
                id= Int32.Parse(parsed[0]),
                dX = Double.Parse(speed[0]), dY = Double.Parse(speed[1]),
                X = Double.Parse(location[0]), Y = Double.Parse(location[1]),
                Fuel = Double.Parse(parsed[3]),
                PlatformStart = Double.Parse(platform[0]), PlatformEnd = Double.Parse(platform[1])
            };
        }
    }

    public class Status
    {
        public bool End { get; set; } = false;
        public bool Success { get; set; }
        public string Url { get; set; }
        public int id { get; set; }
        public double X { get; set; }
        public double Y { get; set; }
        public double dX { get; set; }
        public double dY { get; set; }
        public double Fuel { get; set; }
        public double PlatformStart { get; set; }
        public double PlatformEnd { get; set; }
    }
}
