﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Apollo
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            if (args.Length > 0)
            {//SET AUTOPILOT
                autopilot(args).Wait();
                return;
            }
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        static async Task autopilot(string[] args)
        {
            //args = new[] {"localhost:8000", "6"};
            Console.WriteLine($"Starting Autopilot at: {args[0]}!");
            var maxspeed = float.MaxValue;
            if (args.Length > 1)
            {

                var tmp = float.Parse(args[1]);
                if (tmp != 0)
                {
                    maxspeed = tmp;
                    Console.WriteLine("With Max speed of: " + tmp);
                }
            }
            var temp = Lander.New(args[0]);
            temp.Wait();
            var responce = temp.Result;
            var stopping = false;
            while (true)
            {

                Thread.Sleep(10);

                var midPointX = responce.PlatformStart + (responce.PlatformEnd - responce.PlatformStart) / 2;
                var needX = midPointX - responce.X;
                var needY = responce.Y;
                var r = responce;

                stopping = false;
                if (r.dY < -4)
                {
                    var timeToStop =(r.dY / 4);
                    var StopDistance = Math.Pow(-(r.dY) , (2f)) / (2f * 4f);
                    if (StopDistance > r.Y-10)
                        stopping = true;
                }
                else
                {

                    stopping = false;
                }
                if (Math.Abs(r.dY) > maxspeed-2)
                    stopping = true;
                // if(r.Y / r.dY )
                temp = Lander.Update(responce.Url, responce.id, stopping, false, false);
                temp.Wait();
                responce = temp.Result;
                if (responce.End)
                {
                    Console.WriteLine("END: " + (responce.Success ? "Success" : "Crash"));
                    break;
                }
                
                Console.Clear();
                Console.WriteLine("Location: " + responce.X + ":" + responce.Y);
                Console.WriteLine("Speed: " + responce.dX + ":" + responce.dY);
                Console.WriteLine("Platform: " + responce.PlatformStart + ":" + responce.PlatformEnd);
                Console.WriteLine("Fuel: " + responce.Fuel);
                Console.WriteLine("NeedX: " + needX);
                Console.WriteLine("NeedY: " + needY);
                    Console.ForegroundColor = stopping ? ConsoleColor.Blue : ConsoleColor.Red;
                Console.Write("UP ");
                Console.ForegroundColor = false ? ConsoleColor.Blue : ConsoleColor.Red;
                Console.Write("LEFT ");
                Console.ForegroundColor = false ? ConsoleColor.Blue : ConsoleColor.Red;
                Console.Write("RIGHT ");

                Console.ForegroundColor = ConsoleColor.White;
            }
            Console.ReadKey(true);
            return;
        }
    }
}
